<template>
  <div class="main-mobility">
    <v-fade-transition>
      <div class="loader" v-if="loading">
        Generating Report...
      </div>
    </v-fade-transition>
  <!-- start of ERROR 404 -->
    <div class="errors ma-auto" v-if="error.statusCode === 404">
      <v-container>
        <div>
          <v-row class="d-flex align-center justify-center mb-4">
            <div class="error-title">
              <h1 class="font-weight-black mb-0" style="font-size: 288px; color: #FF5252; height: 323px;">404</h1>
              <h6 class="font-weight-medium" style="font-size: 53px; text-align: center; color: #000;">Page Not Found</h6>
              <p class="font-weight-medium" style="font-size: 24px; text-align: center; color: #000; margin-top: -10px;">The page you were looking for does not exist.</p>
            </div>
          </v-row>
          <v-row no-gutters class="d-flex align-center justify-center mb-4 white" ref="contentMe" v-if="showReport">
            <v-col cols="12" class="pa-2">
              <h2 class="overline">Bug Report : </h2>
              <v-simple-table dense class="pa-2">
                <template v-slot:default>
                  <tbody>
                    <tr>
                      <td>ERROR CODE</td>
                      <td>404</td>
                    </tr>
                    <tr>
                      <td>PATH</td>
                      <td>{{ fullPathing+$route.fullPath }}</td>
                    </tr>
                    <tr>
                      <td>MESSAGE</td>
                      <td>{{ error.message }}</td>
                    </tr>
                  </tbody>
                </template>
              </v-simple-table>
            </v-col>
          </v-row>
          <v-row class="d-flex justify-center flex-wrap">
            <v-btn class="ma-2 v-btn--outlined v-size--small primary--text elevation-0">
              <NuxtLink  to="/" style="text-decoration: none; text-transform: uppercase; font-size: .75rem;">Back To Dashboard</NuxtLink>
            </v-btn>
            <v-btn class="ma-2 v-btn--outlined v-size--small danger--text elevation-0" @click="reportMe404">
              <a style="text-decoration: none; text-transform: uppercase; font-size: .75rem; color: #FF5252;">Report the problem</a>
            </v-btn>
          </v-row>
        </div>
      </v-container>
    </div>
  <!-- end of ERROR 404 -->
  <!-- start of ERROR 500 -->
    <div class="errors ma-auto" v-if="error.statusCode === 500">
      <v-container>
        <div>
          <v-row class="d-flex align-center justify-center mb-4">
            <div class="error-title">
              <h1 class="font-weight-black mb-0" style="font-size: 288px; color: #FF5252; height: 323px;">500</h1>
              <h6 class="font-weight-medium" style="font-size: 53px; text-align: center; color: #000;">Internal Server Error</h6>
              <p class="font-weight-medium" style="font-size: 24px; text-align: center; color: #000; margin-top: -10px;">We’re experiencing internal server problem. <br>Please try again.</p>
            </div>
          </v-row>
          <v-row no-gutters class="d-flex align-center justify-center mb-4 white" ref="contentMe" v-if="showReport">
            <v-col cols="12" class="pa-2">
              <h2 class="overline">Bug Report : </h2>
              <v-simple-table dense class="pa-2">
                <template v-slot:default>
                  <tbody>
                    <tr>
                      <td>ERROR CODE</td>
                      <td>500</td>
                    </tr>
                    <tr>
                      <td>PATH</td>
                      <td>{{ fullPathing+$route.fullPath }}</td>
                    </tr>
                    <tr>
                      <td>FILE PATH</td>
                      <td>{{ error.file }}</td>
                    </tr>
                    <tr>
                      <td>CODE LINE</td>
                      <td>{{ error.line }}</td>
                    </tr>
                    <tr>
                      <td>MESSAGE</td>
                      <td>{{ error.message }}</td>
                    </tr>
                  </tbody>
                </template>
              </v-simple-table>
            </v-col>
          </v-row>
          <v-row class="d-flex justify-center flex-wrap">
            <v-btn class="ma-2 v-btn--outlined v-size--small primary--text elevation-0">
              <NuxtLink to="/" style="text-decoration: none; text-transform: uppercase; font-size: .75rem;" v-if="$route.name != 'home'">Back To Dashboard</NuxtLink>
              <a href="/" style="text-decoration: none; text-transform: uppercase; font-size: .75rem;">Reload Page</a>
            </v-btn>
            <v-btn class="ma-2 v-btn--outlined v-size--small danger--text elevation-0" @click="reportMe500">
              <a style="text-decoration: none; text-transform: uppercase; font-size: .75rem; color: #FF5252;">Report the problem</a>
            </v-btn>
          </v-row>
        </div>
      </v-container>
    </div>
  <!-- end of ERROR 500 -->
  <!-- start of ERROR 400 -->
    <div class="errors ma-auto" v-if="error.statusCode === 400">
      <v-container>
        <div>
          <v-row class="d-flex align-center justify-center mb-4">
            <div class="error-title">
              <h1 class="font-weight-black mb-0" style="font-size: 288px; color: #FF5252; height: 323px;">400</h1>
              <h6 class="font-weight-medium" style="font-size: 53px; text-align: center; color: #000;">Bad Request</h6>
              <p class="font-weight-medium" style="font-size: 24px; text-align: center; color: #000; margin-top: -10px;">The server could not understand the <br>request due to invalid syntax.</p>
            </div>
          </v-row>
          <v-row class="d-flex justify-center flex-wrap">
            <v-btn class="ma-2 v-btn--outlined v-size--small primary--text elevation-0">
              <NuxtLink to="/" style="text-decoration: none; text-transform: uppercase; font-size: .75rem;">Back To Dashboard</NuxtLink>
            </v-btn>
            <v-btn class="ma-2 v-btn--outlined v-size--small danger--text elevation-0">
              <NuxtLink to="/" style="text-decoration: none; text-transform: uppercase; font-size: .75rem; color: #FF5252;">Report the problem</NuxtLink>
            </v-btn>
          </v-row>
        </div>
      </v-container>
    </div>
  <!-- end of ERROR 400 -->
  <!-- start of ERROR 403 -->
    <div class="errors ma-auto" v-if="error.statusCode === 403">
      <v-container>
        <div>
          <v-row class="d-flex align-center justify-center mb-4">
            <div class="error-title">
              <h1 class="font-weight-black mb-0" style="font-size: 288px; color: #FF5252; height: 323px;">403</h1>
              <h6 class="font-weight-medium" style="font-size: 53px; text-align: center; color: #000;">Request Forbidden</h6>
              <p class="font-weight-medium" style="font-size: 24px; text-align: center; color: #000; margin-top: -10px;">You do not have no access rights <br>to this content.</p>
            </div>
          </v-row>
          <v-row class="d-flex justify-center flex-wrap">
            <v-btn class="ma-2 v-btn--outlined v-size--small primary--text elevation-0">
              <NuxtLink to="/" style="text-decoration: none; text-transform: uppercase; font-size: .75rem;">Back To Dashboard</NuxtLink>
            </v-btn>
            <v-btn class="ma-2 v-btn--outlined v-size--small danger--text elevation-0">
              <NuxtLink to="/" style="text-decoration: none; text-transform: uppercase; font-size: .75rem; color: #FF5252;">Report the problem</NuxtLink>
            </v-btn>
          </v-row>
        </div>
      </v-container>
    </div>
  <!-- end of ERROR 403 -->
  <!-- start of ERROR 405 -->
    <div class="errors ma-auto" v-if="error.statusCode === 405">
      <v-container>
        <div>
          <v-row class="d-flex align-center justify-center mb-4">
            <div class="error-title">
              <h1 class="font-weight-black mb-0" style="font-size: 288px; color: #FF5252; height: 323px;">405</h1>
              <h6 class="font-weight-medium" style="font-size: 53px; text-align: center; color: #000;">Method Not Allowed</h6>
              <p class="font-weight-medium" style="font-size: 24px; text-align: center; color: #000; margin-top: -10px;">The request method is known by the server <br>but is not supported by the <br>target resource.</p>
            </div>
          </v-row>
          <v-row class="d-flex justify-center flex-wrap">
            <v-btn class="ma-2 v-btn--outlined v-size--small primary--text elevation-0">
              <NuxtLink to="/" style="text-decoration: none; text-transform: uppercase; font-size: .75rem;">Back To Dashboard</NuxtLink>
            </v-btn>
            <v-btn class="ma-2 v-btn--outlined v-size--small danger--text elevation-0">
              <NuxtLink to="/" style="text-decoration: none; text-transform: uppercase; font-size: .75rem; color: #FF5252;">Report the problem</NuxtLink>
            </v-btn>
          </v-row>
        </div>
      </v-container>
    </div>
  <!-- end of ERROR 405 -->
  </div>
</template>

<script>
import domtoimage from "dom-to-image-more";
import Cookies from 'js-cookie'
export default {
//adsaasdadasdasdasdasdasd
  props : [ 'error' ],

  layout: 'simple',

  data(){
    return {
      loading : false,
      fullPathing : window.location.origin,
      showReport : false
    }
  },

  created(){
    this.$vuetify.theme.dark = false
    Cookies.set('isDark', true)
  },

  destroyed(){
    this.$vuetify.theme.dark = Cookies.get('isDark')
    Cookies.remove('isDark')
  },

  methods : {

    async reportMe500(){
      this.loading = true
      setTimeout(()=>{
        this.showReport = true
        setTimeout(()=>{
          var node = this.$refs.contentMe
          domtoimage.toPng(node)
            .then((dataUrl)=>{
              var link = document.createElement("a");
              link.download = "suiterus-bug-report"+new Date()+".jpeg";
              link.href = dataUrl;
              link.click();
              this.showReport = false
              this.loading = false
            })
        },400)
      },400)
    },

    async reportMe404(){
      this.loading = true
      setTimeout(()=>{
        this.showReport = true
        setTimeout(()=>{
          var node = this.$refs.contentMe
          domtoimage.toPng(node)
            .then((dataUrl)=>{
              var link = document.createElement("a");
              link.download = "suiterus-bug-report"+new Date()+".jpeg";
              link.href = dataUrl;
              link.click();
              this.showReport = false
              this.loading = false
            })
        },400)
      },400)
    }

  }

}
</script>

<style scoped>
.main-mobility { 
  height : 100vh;
  display: flex;
  align-items: center;
  justify-content: center;
  position : relative
}
.loader {
  height : 100vh;
  background : #000; 
  display : flex; 
  align-items : center; 
  justify-content : center; 
  position : absolute; 
  width : 100vw;
  color : #eee; 
  z-index : 9999
}
</style>